// *****************************************************************************
// Module de gestion des moteurs pas  pas
// (C) Morin Pascal 2001-2002
// *****************************************************************************
#include <reg51f.h>
#include "stepper.h"

extern void wait(int);

// *****************************************************************************
// variables globales du module
// *****************************************************************************

unsigned char 	state_a;
int 		   	count_a;
unsigned char 	speed_a;
unsigned char 	time_a;
bit		   		over_a;


// ***************************************************************************
// place les moteurs au repos
// ***************************************************************************
void init_stepper(void)
{
en3=0;						// moteur en "roue libre"
en4=0;
step1=0;
step2=0;
step3=0;
step4=0;
state_a=STEP_PHASE1;		// position initiales
count_a=0;					// pas progression en cours
speed_a=10;					// 10 ms par dfaut entre chaque pas
time_a=0;					// aucune attente en cours
over_a=0;


}



// ***************************************************************************
// gere la progression des moteurs
// ***************************************************************************
void gere_stepper(void) using 2
{
// ----------------------------------------------------------------------------
// gestion du moteur pas  pas
// ----------------------------------------------------------------------------
if (count_a)							// reste-t-il des pas  raliser ?
	{
	if (time_a) time_a--;				// decompte le temps d'attente entre les phases
	else
		{
 		time_a=speed_a;					// recharge le temps d'attente
  		
 		if (count_a>0)					// sens horaire ?
  			{
  	 		// tourne dans le sens horaire
  	  		count_a--;					// decompte le nb de pas restant
  	   		
  	   		// dtermine le nouvel tat  appliquer pour progresser
  	   		// d'un pas dans le sens horaire
  	   		switch(state_a)				
  	   			{
  	   	 		case	STEP_PHASE1:	state_a=STEP_PHASE2;
  	   	      	                        break;
  	   	 		case	STEP_PHASE2:	state_a=STEP_PHASE3;
  	   	      	                        break;
  	   	 		case	STEP_PHASE3:	state_a=STEP_PHASE4;
  	   	      	                        break;
  	   	        default:				state_a=STEP_PHASE1;
  	   	      	                        break;
  	   	 		}
  	   	 	
  	 		}
  	  	else
  	  		{
  	 		// tourne dans le sens anti-horaire
  	  		count_a++;

  	   		// dtermine le nouvel tat  appliquer pour progresser
  	   		// d'un pas dans le sens anti-horaire
  	   		switch(state_a)				
  	   			{
  	   	 		case	STEP_PHASE1:	state_a=STEP_PHASE4;
  	   	      	                        break;
  	   	 		case	STEP_PHASE2:	state_a=STEP_PHASE1;
  	   	      	                        break;
  	   	 		case	STEP_PHASE3:	state_a=STEP_PHASE2;
  	   	      	                        break;
  	   	        default:				state_a=STEP_PHASE3;
  	   	      	                        break;
  	   	 		}
  	   		}
  	   		
  	   	// applique le nouvel tat aux signaux de commande
  	   	en3=en4=1;
  	   	switch(state_a)
  	   		{
  	   	 	case	STEP_PHASE1:	step1=1; step2=0; step3=0; step4=0;
  	   	      	                    break;
  	   	 	case	STEP_PHASE2:	step1=1; step2=1; step3=1; step4=0;
  	   	      	                    break;
  	   	 	case	STEP_PHASE3:	step1=0; step2=1; step3=1; step4=1;
  	   	      	                    break;
  	   	 	case	STEP_PHASE4:	step1=0; step2=0; step3=0; step4=1;
  	   	      	                    break;
  	   	 	}
 		}
	}		
}


// ***************************************************************************
// ajoute le nb de pas voulu pour le moteur 1
// ***************************************************************************
void step_motor_a(char x)
{
int n;

EA=0;

if (count_a>=0)				// compte positif en cours ?
	{
	n=0x7fff-count_a;			// calcule la limite avant overflow
	if (x<n) count_a+=x;		// dpasse la limite ?
	else
		{
 		count_a=0x7fff;			// fixe au maximum positif
  		over_a=1;				// mmorise le depassement
  		}
	}
else
	{
	n=0x8000-count_a;			// calcule la limite avant overflow
	if (x>n) count_a+=x;		// dpasse la limite ?
	else
		{
 		count_a=0x8000;			// fixe au maximum ngatif
  		over_a=1;				// mmorise le depassement
  		}
	}

EA=1;
}

// ***************************************************************************
// arrete le moteur 1
// ***************************************************************************
void stop_motor_a(void)
{
EA=0;
count_a=0;
EA=1;
}

// ***************************************************************************
// modifie la vitesse du moteur 1
// ***************************************************************************
void speed_motor_a(unsigned char x)
{
EA=0;
speed_a=x;
EA=1;
}

