//---------------------------------------------------------------------------
#include <vcl.h>
#include <list.h>
#include <string.h>
#pragma hdrstop

#include "Unit1.h"
#include "Unit3.h"
#include "..\cmde.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm3 *Form3;
extern list <item> pgm[16];
int err;

//---------------------------------------------------------------------------
__fastcall TForm3::TForm3(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm3::Button1Click(TObject *Sender)
{
Close();    
}
//---------------------------------------------------------------------------

void __fastcall TForm3::FormShow(TObject *Sender)
{
AnsiString msg;
ListBox1->Clear();
ListBox1->Items->Add("Dbut de la vrification");
err=0;
VerifieLabels();
if (!err) ListBox1->Items->Add("Vrification des labels : OK");
VerifiePgm();
if (!err) ListBox1->Items->Add("Vrification finale : OK");

if (err)
    {
    msg=AnsiString(err)+" erreur";
    if (err>1) msg+="s";
    msg+=" trouve";
    if (err>1) msg+="s";
    }
else msg="Pas d'erreur dans les programmes";
ListBox1->Items->Add(msg);
}

//---------------------------------------------------------------------------
void __fastcall TForm3::VerifieLabels(void)
{
list<item>::iterator x;
int i,n,lig;
AnsiString msg;

// vrifie si tous les labels appels sont dfinis
for (i=0;i<16;i++)      // scan tout les programmes
    {
    lig=1;
    for (x=pgm[i].begin();x!=pgm[i].end();x++)
        {
        switch((*x).type)
            {
            case    CALL:
            case    JUMP:               // recherche le label (visibilit dans tous les programmes)
                            n=FindLabel((*x).label);
                            if (!n)
                                {
                                err++;
                                msg="Le label <"+AnsiString((*x).label)+"> n'est pas dfini (pgm:"+AnsiString(i)+" ligne:"+AnsiString(lig)+")";
                                ListBox1->Items->Add(msg);
                                }
                            break;

            case    LABEL:               // recherche le label (visibilit dans tous les programmes)
                            n=FindLabel((*x).label);
                            if (n>1)
                                {
                                err++;
                                msg="Le label <"+AnsiString((*x).label)+"> est dfini plusieurs fois (pgm:"+AnsiString(i)+" ligne:"+AnsiString(lig)+")";
                                ListBox1->Items->Add(msg);
                                }
                            break;

            default:        break;      // rien a faire pour les autres actions
            }
        lig++;
        }
    }
}


//---------------------------------------------------------------------------
int __fastcall TForm3::FindLabel(char * l)
{
list<item>::iterator x;
int i,n=0;

for (i=0;i<16;i++)      // scan tout les programmes
    {
    for (x=pgm[i].begin();x!=pgm[i].end();x++)
        {
        if((*x).type==LABEL)
            {
            if (strcmp((*x).label,l)==0) n++;
            }
        }
    }
return(n);
}


//---------------------------------------------------------------------------
void __fastcall TForm3::VerifiePgm(void)
{
list<item>::iterator x;
int i,n=0;
AnsiString msg;

for (i=0;i<16;i++)      // scan tout les programmes
    {
    for (x=pgm[i].begin();x!=pgm[i].end();x++)
        {
        switch((*x).type)
            {
            case CMDE_END:      n+=1;
                                break;
            case CMDE_STOP:     n+=2;
                                break;
            case CMDE_STEPPER:  n+=3;
                                break;
            case CMDE_MOT:      n+=2;
                                break;
            case WAIT:          n+=3;
                                break;
            case CALL:          n+=3;
                                break;
            case RETURN:        n+=1;
                                break;
            case JUMP:          n+=3;
                                break;
            case DBG:           n+=2;
                                break;
            case CMDE_IDLE:     n+=2;
                                break;
            case LABEL:         break;      // cette instruction ne gnere pas de code
            default:            msg="Erreur de logique interne (Code inconnu:"+AnsiString((*x).type)+")";
                                ListBox1->Items->Add(msg);
            }
        }
    }

if (n>0x7fff)
    {
    err++;
    msg="La taille des programmes dpasse les capacits de la mmoire de l'appareil";
    ListBox1->Items->Add(msg);
    }
}
