// ***********************************************************************
// Liste des commandes interpretes par l'appareil
// ***********************************************************************

#ifndef CMDE
#define CMDE
// *****************************************************************************


enum {CMDE_END=0xff, CMDE_STOP=0, CMDE_STEPPER, CMDE_MOT, WAIT, CALL, RETURN, JUMP, DBG, CMDE_IDLE, LABEL};

/* ----------------------------------------------------------------------
 description des arguments des commandes:

 CDME_END 		--> Pas d'argument

 CMDE_STOP nn	-->	nn = moteur  stopper
 					bit 0 = 1  -> arret du moteur n1
 					bit 1 = 1  -> arret du moteur n2
 					bit 2 = 1  -> arret du moteur pas  pas
					bits 3  7 -> don't care

 CMDE_STEPPER nn dd --> nn = nombre de pas (+128/-127), dd = vitesse du pas en ms

 CMDE_MOT nn	--> nn = moteur  mettre en marche
 					bit 0 = 1  -> mise en marche du moteur n1
					bit 1      -> sens du moteur n1
 					bit 2 = 1  -> mise en marche du moteur n2
					bit 3      -> sens du moteur n2
					bits 4  7 -> don't care

 WAIT dddd		--> dddd = dure d'attente en ms

 CALL HHLL		--> HHLL = pointeur sur la prochaine instruction (8 niveaux max)

 RETURN			--> retour  l'instruction qui suit le CALL

 JUMP HHLL		--> HHLL = pointeur sur la prochaine instruction

 DBG xx			--> mode debug ON (xx!=0) OFF (xx=0)

 CMDE_IDLE nn	--> nn = moteur  mettre en roue libre
 					bit 0 = 1  -> moteur n1 en roue libre
 					bit 1 = 1  -> moteur n2 en roue libre
 					bit 2 = 1  -> moteur pas  pas en roue libre
					bits 3  7 -> don't care

 ----------------------------------------------------------------------- */
 
#endif

