NAME	FLASH_P89C51RD
;****************************************************************************
;Gere la programmation d'un bloc de donne en mmoire flash
;(C) Morin Pascal 2002
;****************************************************************************

public	_prog_byte_flash
public	_erase_block_flash


AUXR1  DATA 0A2h

;******************************************************************************
;dfinition des constantes
;******************************************************************************
PGM_MTP 	equ	0FFF0H		; adresse du point d'entre des fonctions de programmation du P89C51
IAP_PROG_BYTE	equ	02h
IAP_ERASE_BLOCK	equ	01h

FREQ		equ	12		; frquence du quartz en MHz


;******************************************************************************
;declaration des segments necessaires pour le module
;******************************************************************************
?PR?_prog_byte_flash?FLASH_P89C51RD	segment	code
?PR?_erase_block_flash?FLASH_P89C51RD	segment	code


;********************************************************************************
;bit _prog_byte_flash(unsigned char dat, unsigned int dest_addr)
;********************************************************************************
;en entree R7 = dat, R4:R5 = dest_addr
;en sortie c=status (0:FAIL, 1:OK)
;********************************************************************************
Rseg	?PR?_prog_byte_flash?FLASH_P89C51RD

		using 0
_prog_byte_flash:
		push	AUXR1
		mov	a,AUXR1
		setb	acc.5			;positionne le bit correspondant  ENBOOT
		mov	AUXR1,a			;rend la selection active
		mov	r0,#FREQ
		mov	r1,#IAP_PROG_BYTE
		mov	dph,r4
		mov	dpl,r5
		mov	ACC,r7
		call	PGM_MTP
		pop	AUXR1
		
		ret

;***********************************************************
;bit erase_block_flash(unsigned char block)
;***********************************************************
;en entree R7 = bloc  effacer 
;Bloc 0 -> 0000H  1FFFH (8Ko)
;Bloc 1 -> 2000H  3FFFH (8Ko)
;Bloc 2 -> 4000H  7FFFH (16Ko)
;Bloc 3 -> 8000H  BFFFH (16Ko)
;Bloc 4 -> C000H  FFFFH (16Ko)
;en sortie c=status (0:FAIL, 1:OK)
;***********************************************************
Rseg	?PR?_erase_block_flash?FLASH_P89C51RD

		using 0

erase_table:	db	0
		db	020h
		db	040h
		db	080h
		db	0C0h
		db	0C0h
		db	0C0h
		db	0C0h


_erase_block_flash:
		push	AUXR1
		mov	a,AUXR1
		setb	acc.5			;positionne le bit correspondant  ENBOOT
		mov	AUXR1,a			;rend la selection active
		mov	dptr,#erase_table	;table de conversion
		mov	a,r7			;charge la valeur du bloc  effacer
		anl	a,#07h			;vite le depassement dans la table
		movc	a,@a+dptr		;transforme la valeur
		mov	dph,a
		mov	dpl,#00h
		mov	r0,#FREQ
		mov	r1,IAP_ERASE_BLOCK
		call	PGM_MTP
		pop	AUXR1
		ret

		end